## mongo-c-driver 2.2.0

=== src/CMakeLists.txt ===
# sub-directory 'libbson' was already included at the top-level
# sub-directory 'libmongoc' was already included at the top-level
# sub-directory 'kms-message' was already included at the top-level

# Copy zconf.h.in to zconf.h, used by zlib
configure_file (
   "${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/zconf.h.in"
   "${CMAKE_BINARY_DIR}/src/zlib-1.3.1/zconf.h"
   COPYONLY
)

if (CMAKE_CXX_COMPILER)
   # Add a C++ source file that will #include the main C headers. This "library"
   # does nothing other than validate that the C headers are valid C++ headers.
   add_library (mongoc-cxx-check OBJECT cpp-check.cpp)
   if (TARGET mongoc::static)
      target_link_libraries (mongoc-cxx-check PRIVATE mongoc::static)
   else ()
      target_link_libraries (mongoc-cxx-check PRIVATE mongoc::shared)
   endif ()
endif ()

# public-header-warnings
add_executable(public-header-warnings EXCLUDE_FROM_ALL ${CMAKE_CURRENT_SOURCE_DIR}/c-check.c)

if (TARGET mongoc::static)
   target_link_libraries(public-header-warnings PRIVATE mongoc::static)
else ()
   target_link_libraries(public-header-warnings PRIVATE mongoc::shared)
endif ()

target_compile_options(public-header-warnings PRIVATE
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Weverything>
  $<$<C_COMPILER_ID:GNU>:-Wextra>
  $<$<C_COMPILER_ID:AppleClang,Clang,GNU>:-Werror>
  $<$<C_COMPILER_ID:AppleClang,Clang,GNU>:-Wno-declaration-after-statement>
  $<$<C_COMPILER_ID:AppleClang,Clang,GNU>:-Wno-disabled-macro-expansion>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-c++98-compat-pedantic>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-pre-c11-compat>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-pre-c2x-compat>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-unsafe-buffer-usage>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-padded>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-reserved-identifier>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-documentation-unknown-command>
  $<$<C_COMPILER_ID:AppleClang,Clang>:-Wno-unknown-warning-option>
  $<$<C_COMPILER_ID:AppleClang>:-Wno-poison-system-directories>
  $<$<C_COMPILER_ID:MSVC>:/W4>
  $<$<C_COMPILER_ID:MSVC>:/WX>
  $<$<C_COMPILER_ID:MSVC>:/wd4324>
)

=== debian/changelog ===
mongo-c-driver (2.2.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1118303)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 25 Nov 2025 19:55:18 -0500

## mongo-c-driver 2.2.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15...4.0)

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_LIST_DIR}/build/cmake")
# Defines BUILD_VERSION, which we use throughout:
include (BuildVersion)

project (
   mongo-c-driver
   LANGUAGES C
   # BUILD_VERSION_SIMPLE is a CMake-compatible version number that omits suffixes
   VERSION "${BUILD_VERSION_SIMPLE}"
)

# Set MONGOC_MAJOR_VERSION, MONGOC_MINOR_VERSION, etc.
include (ParseVersion)
ParseVersion ("${BUILD_VERSION}" MONGOC)
# Defines additional similar variables:
include (LoadVersion)
LoadVersion (VERSION_CURRENT MONGOC)

# Extended version attributes that CMake doesn't (yet) understand, which include
# the prerelease tag. Named here to match the variables generated by project()
set(mongo-c-driver_VERSION_PRERELEASE ${MONGOC_PRERELEASE_VERSION})
set(mongo-c-driver_VERSION_FULL ${MONGOC_VERSION})

include(FeatureSummary)

include (MongoSettings)
include (MongoPlatform)
include (GeneratePkgConfig)
include (VerifyHeaders)

# Subcomponents:
mongo_bool_setting(ENABLE_MONGOC "Enable the build of libmongoc libraries (The MongoDB C database driver)")
mongo_bool_setting(
   USE_SYSTEM_LIBBSON [[Use an existing libbson library (via find_package()) instead of building one from source]]
   DEFAULT VALUE OFF
   ADVANCED
)

# Deprecated option "ENABLE_BSON" is gone, but old caches may rely on SYSTEM to
# disable the libbson build. Allow ENABLE_BSON=SYSTEM only if USE_SYSTEM_LIBBSON
# is also true, to allow both ENABLE_BSON=SYSTEM and USE_SYSTEM_LIBBSON=TRUE to
# simplify downstream build scripts
if(ENABLE_BSON STREQUAL "SYSTEM" AND NOT USE_SYSTEM_LIBBSON)
   # User set ENABLE_BSON=SYSTEM, so they intend for us to build against an external
   # libbson, but they didn't set USE_SYSTEM_LIBBSON=ON, so they are probably
   # unaware of this change. Rather than miscompile, stop what we're doing:
   message(FATAL_ERROR "ENABLE_BSON=SYSTEM is no longer supported. Use USE_SYSTEM_LIBBSON=ON for the same effect.")
endif()

# Toggle static libraries:
mongo_setting(
   ENABLE_STATIC "Enable building and installing static library archive artifacts"
   OPTIONS ON OFF BUILD_ONLY
   DEFAULT VALUE "ON"
)
# Toggle dynamic libraries:
mongo_bool_setting(ENABLE_SHARED "Enable building and installing dynamic library artifacts")

# Toggle PIC
if(NOT WIN32)
   mongo_bool_setting(ENABLE_PIC "Enable position-independent code when building static libraries (Not applicable on Windows)")
elseif(DEFINED ENABLE_PIC)
   # We are on Windows, and ENABLE_PIC is defined.
   message(STATUS "ENABLE_PIC=“${ENABLE_PIC}” has no effect on Windows (All Windows code is position-independent)")
else()
   # We are on Windows, and ENABLE_PIC is not defined, which is normal
endif()

# Dev mode checks:
mongo_bool_setting(
   ENABLE_MAINTAINER_FLAGS "Enable stricter build-time checks"
   DEFAULT VALUE OFF
      DEVEL EVAL [[
         if(MSVC)
            set(DEFAULT OFF)
         else()
            set(DEFAULT ON)
         endif()
      ]])

# Toggle instrumentation:
mongo_bool_setting(ENABLE_TRACING "Enable runtime tracing output in the built libmongoc (Very noisy!)"
                   DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_COVERAGE "Build code with coverage instrumentation"
                   DEFAULT VALUE OFF DEVEL VALUE ON)
mongo_bool_setting(ENABLE_DEBUG_ASSERTIONS "Build library with runtime debug assertions enabled"
                   DEFAULT VALUE OFF DEVEL VALUE ON)
# for MONGO_SANITIZE:
include(Sanitizers)

# Toggle optional components:
mongo_bool_setting(ENABLE_TESTS "Enable building MongoDB C Driver tests")
mongo_bool_setting(ENABLE_EXAMPLES "Enable building MongoDB C Driver examples")
mongo_bool_setting(ENABLE_MAN_PAGES "Enable building the manual pages" DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_HTML_DOCS "Enable building the HTML documentation" DEFAULT VALUE OFF)
mongo_bool_setting(ENABLE_UNINSTALL "Generate an 'uninstall' script and an 'uninstall' build target")
mongo_bool_setting(ENABLE_SRV "Enable support for mongodb+srv URIs.")

# Optional features that are ENABLED when necessary dependencies are found:
mongo_setting(ENABLE_SNAPPY "Enable Snappy compression support"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_ZSTD "Enable zstd compression support"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_ZLIB "Enable zlib compression support"
              OPTIONS BUNDLED SYSTEM OFF
              DEFAULT VALUE BUNDLED)
mongo_bool_setting(USE_BUNDLED_UTF8PROC "Enable building with utf8proc. Needed for SCRAM-SHA-256 authentication with non-ASCII passwords"
                   ADVANCED)
mongo_setting(
   ENABLE_SSL [[Enable TLS connection and SCRAM authentication.]]
   OPTIONS WINDOWS DARWIN OPENSSL OFF AUTO
   DEFAULT VALUE AUTO
   VALIDATE CODE [[
      if(ENABLE_SSL STREQUAL "DARWIN" AND NOT APPLE)
         message(WARNING "ENABLE_SSL=DARWIN is only supported on Apple platforms")
      elseif(ENABLE_SSL STREQUAL "WINDOWS" AND NOT WIN32)
         message(WARNING "ENABLE_SSL=WINDOWS is only supported on Windows platforms")
      endif()
   ]]
)
mongo_bool_setting(
   ENABLE_SHM_COUNTERS "Enable memory performance counters"
   DEFAULT EVAL [[
      set(DEFAULT OFF)
      if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" OR (APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm64"))
         set(DEFAULT ON)
      endif()
   ]]
   VALIDATE CODE [[
      if(ENABLE_SHM_COUNTERS
         AND NOT CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux"
         AND NOT (APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm64"))
         message(WARNING "ENABLE_SHM_COUNTERS=ON is only supported on Linux or ARM Darwin")
      endif()
   ]]
)

mongo_setting(
   ENABLE_SASL "Enable SASL authentication (Kerberos)"
   OPTIONS CYRUS SSPI OFF AUTO
   DEFAULT VALUE AUTO
   VALIDATE CODE [[
      if(ENABLE_SASL STREQUAL "SSPI" AND NOT WIN32)
         message(WARNING "ENABLE_SASL=SSPI is only supported on Windows platforms")
      endif()
      if(ENABLE_SASL STREQUAL "CYRUS" AND WIN32)
         message(WARNING "ENABLE_SASL=CYRUS on Windows platforms is unsupported. Use ENABLE_SASL=SSPI or ENABLE_SASL=OFF instead")
      endif()
   ]]
)

mongo_setting(ENABLE_CLIENT_SIDE_ENCRYPTION "Enable In-Use Encryption support. Requires additional support libraries."
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO)
mongo_setting(ENABLE_MONGODB_AWS_AUTH "Enable support for the MONGODB-AWS authentication mechanism"
              OPTIONS ON OFF AUTO
              DEFAULT VALUE AUTO
              VALIDATE CODE [[
                  if(NOT ENABLE_MONGODB_AWS_AUTH STREQUAL "ON")
                     return()
                  endif()
                  if(MSVC AND MSVC_VERSION LESS 1900)
                     message(FATAL_ERROR "Visual Studio 2015 or newer is required for ENABLE_MONGODB_AWS_AUTH=ON")
                  elseif(ENABLE_SSL STREQUAL "OFF")
                     message(FATAL_ERROR "ENABLE_MONGODB_AWS_AUTH=ON requires that ENABLE_SSL not be 'OFF'")
                  endif()
              ]])

# Optional features that are DISABLED by default:
mongo_bool_setting(ENABLE_RDTSCP "Enable fast performance counters using the Intel RDTSCP instruction"
                   DEFAULT VALUE OFF)
mongo_bool_setting(
   ENABLE_CRYPTO_SYSTEM_PROFILE "Use system crypto profile"
   DEFAULT VALUE OFF
   VALIDATE CODE [[
      if(ENABLE_CRYPTO_SYSTEM_PROFILE AND NOT ENABLE_SSL STREQUAL "OPENSSL")
         message(WARNING "ENABLE_CRYPTO_SYSTEM_PROFILE=TRUE is only applicable when ENABLE_SSL=OPENSSL")
      endif()
   ]]
)

# Announce the build configuration. Used by `mlib_build_config_is()` in `mlib/config.h`
add_compile_definitions(_MLIB_BUILD_CONFIG=$<CONFIG>)

if(ENABLE_COVERAGE)
   mongo_platform_link_options(--coverage)
   mongo_platform_compile_options($<BUILD_INTERFACE:--coverage>)

   include(CheckCCompilerFlag)
   check_c_compiler_flag("-fprofile-update=prefer-atomic" mongo_c_driver_prefer_atomic)
   if("$CACHE{mongo_c_driver_prefer_atomic}")
      # Avoid "ERROR: Unexpected negative count" errors on some newer platforms.
      mongo_platform_compile_options($<BUILD_INTERFACE:-fprofile-update=prefer-atomic>)
   endif()
endif()

# Enable multi-threading:
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)
mongo_platform_use_target(Threads::Threads)

set_property(DIRECTORY APPEND PROPERTY pkg_config_LIBS ${CMAKE_THREAD_LIBS_INIT})

if(WIN32)
   # Required for gethostbyname on Windows:
   mongo_platform_link_libraries(ws2_32)
endif()

# librt needed on linux for clock_gettime
find_library(RT_LIBRARY rt PATHS /usr/lib32)
if(RT_LIBRARY)
   mongo_platform_link_libraries(${RT_LIBRARY})
   # Set required libraries for CHECK_FUNCTION_EXISTS
   list(APPEND CMAKE_REQUIRED_LIBRARIES "${RT_LIBRARY}")
   # Export the rt linkage as a pkg-config property:
   get_filename_component(rt_dir "${RT_LIBRARY}" DIRECTORY)
   set_property(DIRECTORY APPEND PROPERTY pkg_config_LIBS "-L${rt_dir}" -lrt)
endif()

# On macOS Big Sur, libm resolves to the SDK's tbd file, like:
# /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/lib/libm.tbd
# Not all consumers can easily link to a tbd file (notably golang will reject a tbd suffix by default)
# macOS includes libm as part of libSystem (along with libc).
# It does not need to be explicitly linked.
if(NOT APPLE)
   find_library(M_LIBRARY m)
   if(M_LIBRARY)
      mongo_platform_link_libraries(${M_LIBRARY})
   endif()
endif()

# Check for an optional C++ compiler. Result included in handshake metadata. Enables optional C++-specific tests.
include (CheckLanguage)
check_language (CXX)
if (CMAKE_CXX_COMPILER)
   enable_language (CXX)
   if (NOT CMAKE_CXX_STANDARD)
      # Default to C++11 for purposes of testing.
      set (CMAKE_CXX_STANDARD 11)
   endif ()
else ()
   message (STATUS "No CXX support")
endif ()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   set (CMAKE_BUILD_TYPE "RelWithDebInfo")
   message (
      STATUS "No CMAKE_BUILD_TYPE selected, defaulting to ${CMAKE_BUILD_TYPE}"
   )
endif ()

include (InstallRequiredSystemLibraries)
include (CMakeDependentOption)

# Installation paths
include (GNUInstallDirs)
# The directory where CMake config packages will be installed, based on the libdir from GNUInstallDirs
mongo_setting(
   MONGO_C_DRIVER_INSTALL_CMAKEDIR "The directory in which CMake package files will be installed"
   TYPE STRING
   DEFAULT VALUE "${CMAKE_INSTALL_LIBDIR}/cmake"
   VALIDATE CODE [[
      if(IS_ABSOLUTE "${MONGO_C_DRIVER_INSTALL_CMAKEDIR}")
         message(SEND_ERROR "The CMake installation directory must be a relative path (Got “${MONGO_C_DRIVER_INSTALL_CMAKEDIR}”)")
      endif()
   ]]
)

include(MongoC-Warnings)

# Enable "maintainer flags," which are supplementary but not mandatory.
# (As opposed to MongoC-Warnings.cmake, which defines "the code is broken" warnings)
if(ENABLE_MAINTAINER_FLAGS)
   mongoc_add_warning_options(
      gnu-like:-Werror
      gnu-like:-pedantic
      gnu-like:-Wall
      gnu-like:-Wempty-body
      gnu:not-gcc-lt7:-Wexpansion-to-defined
      gnu-like:-Winit-self
      gnu-like:-Wmissing-include-dirs
      gnu-like:-Wredundant-decls
      gnu-like:-Wshadow
      gnu-like:lang-c:-Wstrict-prototypes
      gnu-like:-Wswitch-default
      gnu-like:-Wswitch-enum
      gnu-like:-Wundef
      gnu-like:-Wuninitialized
      # Disabled, for now:
      gnu-like:-Wno-strict-aliasing
      gnu-like:-Wno-missing-braces
      # Sign-comparison-mismatch:
      gnu-like:-Wsign-compare
      msvc:/we4018
   )
endif()

# Link with LLD, if possible
if (NOT MSVC)
   include (LLDLinker)
endif ()

if ( (ENABLE_BUILD_DEPENDECIES STREQUAL OFF) AND (NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR) )
   set (ENABLE_BUILD_DEPENDECIES ON)
endif ()

mongo_pick(MONGOC_ENABLE_RDTSCP 1 0 ENABLE_RDTSCP)

mongo_pick(MONGOC_ENABLE_STATIC_BUILD 1 0 ENABLE_STATIC)
mongo_pick(MONGOC_ENABLE_STATIC_INSTALL 1 0

=== src/libmongoc/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15...4.0)

project (libmongoc
   LANGUAGES C
   # Inherit the version from mongo-c-driver
   VERSION "${PROJECT_VERSION}"
   DESCRIPTION "The MongoDB C Database Driver library"
)

# These values are inherited from the mongo-c-driver parent. These are named as to
# match the CMake variables generated by project().
set(libmongoc_VERSION_PRERELEASE ${mongo-c-driver_VERSION_PRERELEASE})
set(libmongoc_VERSION_FULL ${mongo-c-driver_VERSION_FULL})

include (CheckSchedGetCPU)
include (CheckStructHasMember)
include (CheckSymbolExists)
include (CheckTypeSize)
include (CMakePushCheckState)
include (InstallRequiredSystemLibraries)

message (STATUS "libmongoc version (from VERSION_CURRENT file): ${MONGOC_VERSION}")

# Defaults.
set (MONGOC_ENABLE_COMPRESSION 0)
set (MONGOC_ENABLE_COMPRESSION_SNAPPY 0)
set (MONGOC_ENABLE_COMPRESSION_ZLIB 0)
set (MONGOC_ENABLE_COMPRESSION_ZSTD 0)

if(NOT DEFINED MONGOC_INSTALL_INCLUDEDIR)
   set(MONGOC_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/mongoc-${PROJECT_VERSION}")
endif()
if(NOT DEFINED MONGOC_INSTALL_CMAKEDIR)
   set(MONGOC_INSTALL_CMAKEDIR "${MONGO_C_DRIVER_INSTALL_CMAKEDIR}/mongoc-${PROJECT_VERSION}")
endif()

# Definition for mongoc-config.h:
mongo_pick(MONGOC_ENABLE_SRV 1 0 ENABLE_SRV)

set (MONGOC_OUTPUT_BASENAME "mongoc" CACHE STRING "Output mongoc library base name")

if (NOT ENABLE_ZLIB MATCHES "SYSTEM|AUTO|BUNDLED|OFF")
   message (FATAL_ERROR
      "ENABLE_ZLIB option must be SYSTEM, BUNDLED, AUTO, or OFF"
      )
endif ()

if (NOT ENABLE_ZSTD MATCHES "ON|AUTO|OFF")
   message (FATAL_ERROR "ENABLE_ZSTD option must be ON, AUTO, or OFF")
endif ()

set (ZLIB_INCLUDE_DIRS "")
if (ENABLE_ZLIB MATCHES "SYSTEM|AUTO")
   message (STATUS "Searching for zlib CMake packages")
   include (FindZLIB)
   if (ZLIB_FOUND)
      message (STATUS "   zlib found version \"${ZLIB_VERSION_STRING}\"")
      message (STATUS "   zlib include path \"${ZLIB_INCLUDE_DIRS}\"")
      message (STATUS "   zlib libraries \"${ZLIB_LIBRARIES}\"")
   else ()
      if (ENABLE_ZLIB STREQUAL "SYSTEM")
         message (FATAL_ERROR
            "Unable to find system zlib package. Either specify the zlib \
            location by setting ZLIB_ROOT, or else set ENABLE_ZLIB=BUNDLED or \
            set ENABLE_ZLIB=OFF."
            )
      endif ()
      set (ZLIB_LIBRARIES "")
   endif ()
endif ()

if ( (ENABLE_ZLIB STREQUAL "BUNDLED")
   OR (ENABLE_ZLIB STREQUAL "AUTO" AND NOT ZLIB_FOUND) )
   message (STATUS "Enabling zlib compression (bundled)")
   add_library (zlib_obj OBJECT
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/adler32.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/crc32.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/deflate.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/infback.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/inffast.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/inflate.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/inftrees.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/trees.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/zutil.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/compress.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/uncompr.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzclose.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzlib.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzread.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzwrite.c
   )
   set_property (TARGET zlib_obj PROPERTY POSITION_INDEPENDENT_CODE TRUE)
   # This tells the bundled zlib where to find its generated headers
   target_include_directories (zlib_obj
      BEFORE PUBLIC
      "${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1"
      "${CMAKE_BINARY_DIR}/src/zlib-1.3.1"
   )
   # Disable all warnings for compiling Zlib
   target_compile_options (zlib_obj PRIVATE -w)
   set (SOURCES ${SOURCES} $<TARGET_OBJECTS:zlib_obj>)
   # This tells mongoc_shared/mongoc_static where to find generated zlib headers
   set (
      ZLIB_INCLUDE_DIRS
      "${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1"
      "${CMAKE_BINARY_DIR}/src/zlib-1.3.1"
   )
endif ()

if (NOT ENABLE_ZLIB STREQUAL "OFF")
   # At this point the system zlib was found, or the bundled library was used
   include (CheckIncludeFiles)
   check_include_files ("unistd.h" HAVE_UNISTD_H)
   check_include_files ("stdarg.h" HAVE_STDARG_H)
   if (HAVE_UNISTD_H)
      add_definitions (-DHAVE_UNISTD_H)
      list (APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_UNISTD_H)
   endif ()
   if (HAVE_STDARG_H)
      add_definitions (-DHAVE_STDARG_H)
      list (APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDARG_H)
   endif ()
   set (MONGOC_ENABLE_COMPRESSION 1)
   set (MONGOC_ENABLE_COMPRESSION_ZLIB 1)
else ()
   message (STATUS "Disabling zlib compression")
endif ()

if (NOT ENABLE_ZSTD STREQUAL OFF)
   message (STATUS "Searching for compression library zstd")
   find_package(PkgConfig)
   pkg_check_modules (ZSTD libzstd)

   if (NOT ZSTD_FOUND)
      if (ENABLE_ZSTD MATCHES "ON")
         message (FATAL_ERROR "  Not found")
      else ()
         message (STATUS "  Not found")
      endif ()
   # The compression format below this version isn't supported. See SERVER-43070
   elseif (${ZSTD_VERSION} VERSION_LESS "0.8.0")
      if (ENABLE_ZSTD MATCHES "ON")
         message (FATAL_ERROR "Detected zstd version ${ZSTD_VERSION} but version 0.8.0 required")
      else ()
         message (STATUS "Detected zstd version ${ZSTD_VERSION} but version 0.8.0 required")
      endif ()
   else ()
      message (STATUS "  Found zstd version ${ZSTD_VERSION} in ${ZSTD_INCLUDE_DIRS}")
      set (MONGOC_ENABLE_COMPRESSION 1)
      set (MONGOC_ENABLE_COMPRESSION_ZSTD 1)

      include_directories (${ZSTD_INCLUDE_DIRS})
      link_directories (${ZSTD_LIBRARY_DIRS})
      set (MONGOC_ZSTD_LIBRARIES ${ZSTD_LINK_LIBRARIES})
   endif()
endif()

add_library(_mongoc-dependencies INTERFACE)
add_library(mongo::detail::c_dependencies ALIAS _mongoc-dependencies)
target_link_libraries(_mongoc-dependencies INTERFACE mongo::detail::c_platform)
target_link_libraries(_mongoc-dependencies INTERFACE mongo::detail::c_platform $<$<PLATFORM_ID:Windows>:advapi32.lib>)
install(TARGETS _mongoc-dependencies EXPORT mongoc-targets)
set_property(TARGET _mongoc-dependencies PROPERTY EXPORT_NAME detail::c_dependencies)

# d888888b db      .d8888.
# `~~88~~' 88      88'  YP
#    88    88      `8bo.
#    88    88        `Y8b.
#    88    88booo. db   8D
#    YP    Y88888P `8888Y'

# Pick the TLS library to use.
function(_pick_which_tls_lib ssl_opt)
   # Initial value, if not later set:
   set_property(DIRECTORY PROPERTY _mongoc-tls-backend OFF)
   if(ssl_opt STREQUAL "AUTO")
      # Try to pick one automatically
      _auto_pick_tls_lib()
   elseif(ssl_opt)
      # The user named a TLS library specifically. Use that one:
      _use_named_tls_lib("${ssl_opt}")
   else()
      # User has disabled TLS selection
   endif()
endfunction()

# Attempt to automatically find and use a TLS library for the current platform
function(_auto_pick_tls_lib)
   if(WIN32)
      # Windows has SecureChannel
      _use_named_tls_lib(WINDOWS)
   elseif(APPLE)
      # Apple has SecureTransport
      _use_named_tls_lib(DARWIN)
   else()
      # Try to find one of the common open-source TLS libraries
      find_package(OpenSSL)
      if(OpenSSL_FOUND)
         _use_named_tls_lib(OPENSSL)
      endif()
   endif()
endfunction()

# Per-backend link libs/options:
set(SecureTransport/LINK_LIBRARIES "-framework CoreFoundation" "-framework Security")
set(SecureTransport/pkg_config_LIBS -framework Corefoundation -framework Security)
set(SecureChannel/LINK_LIBRARIES secur32.lib crypt32.lib Bcrypt.lib ncrypt.lib)
set(SecureChannel/pkg_config_LIBS ${SecureChannel/LINK_LIBRARIES})
set(OpenSSL/LINK_LIBRARIES OpenSSL::SSL OpenSSL::Crypto $<$<PLATFORM_ID:Windows>:crypt32.lib>)
set(OpenSSL/pkg_config_LIBS -lssl -lcrypto $<$<PLATFORM_ID:Windows>:crypt32.lib>)
# Use *exactly* the TLS library identified by the given name, which is one of
#  `OPENSSL`, `DARWIN`, or `WINDOWS`.
function(_use_named_tls_lib libname)
   # Use this property to track what package we import for our TLS libraries:
   set_property(DIRECTORY PROPERTY _mongoc-tls-package NO)
   if(libname STREQUAL "OPENSSL")
      find_package(OpenSSL REQUIRED)
      set(backend OpenSSL)
      set_property(DIRECTORY PROPERTY _mongoc-tls-package OpenSSL)
   elseif(libname STREQUAL "DARWIN")
      set(backend SecureTransport)
   elseif(libname STREQUAL "WINDOWS")
      set(backend SecureChannel)
   else()
      message(FATAL_ERROR "Unknown TLS library requested: “${libname}”")
   endif()
   add_library(_mongoc-tls_backend INTERFACE)
   install(TARGETS _mongoc-tls_backend EXPORT mongoc-targets)
   target_link_libraries(_mongoc-dependencies INTERFACE _mongoc-tls_backend)
   set_property(TARGET _mongoc-tls_backend PROPERTY EXPORT_NAME detail::c_tls_backend)
   target_link_libraries(_mongoc-tls_backend INTERFACE ${${backend}/LINK_LIBRARIES})
   target_link_options(_mongoc-tls_backend INTERFACE ${${backend}/LINK_OPTIONS})
   set_property(DIRECTORY PROPERTY _mongoc-tls-backend "${backend}")
endfunction()

_pick_which_tls_lib("${ENABLE_SSL}")
# This property will be set by _pick_which_tls_lib:
get_directory_property(TLS_BACKEND _mongoc-tls-backend)
message(STATUS "libmongoc TLS : ${TLS_BACKEND}")
# Used by *-config.cmake to do a find_dependency():
get_directory_property(TLS_IMPORT_PACKAGE _mongoc-tls-package)
set_package_properties(
   OpenSSL PROPERTIES
   DESCRIPTION "the standard open-source implementation of TLS, X509, and more"
   TYPE OPTIONAL
   PURPOSE "Provides a cryptography and TLS backend"
)

mongo_bool01(MONGOC_ENABLE_SSL [[TLS_BACKEND]])
mongo_bool01(MONGOC_ENABLE_SSL_SECURE_CHANNEL [[TLS_BACKEND STREQUAL "SecureChannel"]])
mongo_bool01(MONGOC_ENABLE_SSL_SECURE_TRANSPORT [[TLS_BACKEND STREQUAL "SecureTransport"]])
mongo_bool01(MONGOC_ENABLE_SSL_OPENSSL [[TLS_BACKEND STREQUAL "OpenSSL"]])

mongo_bool01(MONGOC_ENABLE_CRYPTO [[TLS_BACKEND]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_LIBCRYPTO [[MONGOC_ENABLE_SSL_OPENSSL]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_CNG [[MONGOC_ENABLE_SSL_SECURE_CHANNEL]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_COMMON_CRYPTO [[MONGOC_ENABLE_SSL_SECURE_TRANSPORT]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_SYSTEM_PROFILE [[ENABLE_CRYPTO_SYSTEM_PROFILE]])
add_feature_info("TLS" "${MONGOC_ENABLE_SSL}" "for secure network communication (${TLS_BACKEND})")
add_feature_info("Cryptography" "${MONGOC_ENABLE_CRYPTO}" "cryptographic primitives (${TLS_BACKEND})")

include(CMakePushCheckState)
include(CheckSymbolExists)
if(TLS_BACKEND STREQUAL "OpenSSL")
   # Check for newer OpenSSL string functions
   cmake_push_check_state()
   list(APPEND CMAKE_REQUIRED_LIBRARIES OpenSSL::SSL OpenSSL::Crypto)
   check_symbol_exists(
      ASN1_STRING_get0_data
      "openssl/asn1.h"
      HAVE_ASN1_STRING_GET0_DATA
   )
   cmake_pop_check_state()
endif()
mongo_bool01(MONGOC_HAVE_ASN1_STRING_GET0_DATA [[HAVE_ASN1_STRING_GET0_DATA]])

if(ENABLE_CRYPTO_SYSTEM_PROFILE AND NOT MONGOC_ENABLE_SSL_OPENSSL)
   message (FATAL_ERROR "ENABLE_CRYPTO_SYSTEM_PROFILE is only available with OpenSSL")
endif()

set(_aws_feature_desc "authenticate with MongoDB servers using credentials from AWS instance metadata")
if(ENABLE_MONGODB_AWS_AUTH)
   # We may want AWS auth
   if(NOT MONGOC_ENABLE_SSL)
      # No TLS libs
      if(ENABLE_MONGODB_AWS_AUTH STREQUAL "AUTO")
         # Okay: Just turn it off
         message(STATUS "Note: AWS Authentication was disabled automatically because no TLS library is found/enabled")
         set(_enable_aws_auth FALSE)
         add_feature_info("AWS Authentication" OFF "${_aws_feature_desc}. (Disabled automatically: No TLS backend available)")
      else()
         # Bad
         message(FATAL_ERROR "MongoDB AWS Authentication requires a TLS library, no TLS library was found/enabled")
      endif()
   endif()
   set(_enable_aws_auth TRUE)

=== debian/changelog ===
mongo-c-driver (2.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 11 Dec 2025 14:57:45 -0500

## mongo-c-driver 2.2.2

=== debian/changelog ===
mongo-c-driver (2.2.2-1) unstable; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 13 Feb 2026 16:52:06 -0500

## mongo-c-driver 2.2.3

=== debian/changelog ===
mongo-c-driver (2.2.3-1) unstable; urgency=medium

  * New upstream release
  * Skip documentation during arch-only build. Thanks to Helmut Grohne for the
    patch. (Closes: #1129217)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 03 Mar 2026 13:56:44 -0500

=== debian/control ===
Source: mongo-c-driver
Priority: optional
Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
           Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: dpkg-dev (>= 1.22.5),
               debhelper-compat (= 13),
               cmake,
               libssl-dev,
               pkgconf,
               libmongocrypt-dev (>= 1.12.0) <!pkg.mongo-c-driver.no-libmongocrypt>,
               zlib1g-dev,
               libsasl2-dev,
               libsnappy-dev,
               libutf8proc-dev,
               libzstd-dev
Build-Depends-Indep: furo,
                     python3-sphinx,
                     python3-sphinx-design
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/mongodb/mongo-c-driver
Vcs-Git: https://github.com/mongodb/mongo-c-driver.git
Vcs-Browser: https://github.com/mongodb/mongo-c-driver/tree/master

Package: libmongoc-dev
Section: libdevel
Architecture: any
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: libmongoc2-2 (= ${binary:Version}),
         libbson-dev (= ${binary:Version}),
         libmongocrypt-dev (>= 1.12.0),
         libssl-dev,
         zlib1g-dev,
         libsnappy-dev,
         libsasl2-dev,
         libutf8proc-dev,
         libzstd-dev,
         ${misc:Depends}
Description: MongoDB C client library - dev files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains all files necessary to develop applications which
 use libmongoc.

Package: libmongoc2-2
Architecture: any
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: MongoDB C client library - runtime files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the libmongoc runtime libraries, for applications that
 have been built with libmongoc.

Package: libmongoc-doc
Section: doc
Architecture: all
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: libjs-mathjax,
         ${misc:Depends}
Description: MongoDB C client library - documentation
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the man pages for libmongoc.

Package: libbson-dev
Section: libdevel
Architecture: any
Depends: libbson2-2 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbson.

Package: libbson2-2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbson runtime libraries, for applications that
 have been built with libbson.

Package: libbson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library to parse and generate BSON documents - documentation
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the man pages for libbson.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND := -lpthread
# Link with libatomic on riscv64 to get access to the __atomic_*_1 functions
ifeq ($(DEB_HOST_ARCH),riscv64)
	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif


ifeq (,$(filter libbson-doc libmongoc-doc,$(shell dh_listpackages)))
	DOCS=OFF
else
	DOCS=ON
endif

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_auto_configure:
	[ "$(DOCS)" = "ON" ] || echo "arch-only build; not building documentation"
	echo $(DEB_VERSION_UPSTREAM) > VERSION_CURRENT
	dh_auto_configure -- \
	-DENABLE_MONGOC=ON \
	-DENABLE_MAN_PAGES=$(DOCS) \
	-DENABLE_HTML_DOCS=$(DOCS) \
	-DENABLE_MAINTAINER_FLAGS=ON \
	-DENABLE_TESTS=OFF \
	-DENABLE_ZLIB=SYSTEM \
	-DUSE_BUNDLED_UTF8PROC=OFF

override_dh_auto_clean:
	rm -f VERSION_CURRENT
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp/usr/include -type f -name "*.h" -print0 | \
		xargs -0r sed -i -e 's@\([" ]\)[^ ]*-f\(file\|debug\)-prefix-map=[^ ]*\([" ]\)@\1\3@g'

#override_dh_install:
#	dh_install -a -X.la -Xmongoc-stat -Xdoc/mongo-c-driver -Xdoc/libbson -Xman/man3 -X-priv.so -X-priv.pc --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_auto_test:
	echo "Skip dh_auto_test because upstream CI already tests extensively"
